commit 5d3fc5961f783ab9f9bbe6ecb6af03824c89c6a8
Author: freddy77 <freddy77>
Date:   Tue Jan 12 10:20:41 2010 +0000

    Fix strtok_r function

diff --git a/ChangeLog b/ChangeLog
index 5713f2b..86f1486 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Tue Jan 12 11:20:04 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/replacements/strtok_r.c: Fix strtok_r function
+
 Mon Jan 11 19:14:03 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tds.h src/tds/config.c src/tds/login.c src/tds/mem.c:
 	* src/tds/util.c:
@@ -2118,4 +2121,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2938 2010/01/11 18:14:10 freddy77 Exp $
+$Id: ChangeLog,v 1.2939 2010/01/12 10:20:41 freddy77 Exp $
diff --git a/src/replacements/strtok_r.c b/src/replacements/strtok_r.c
index ba44246..9e417cc 100644
--- a/src/replacements/strtok_r.c
+++ b/src/replacements/strtok_r.c
@@ -18,8 +18,9 @@
 #include "tds_sysdep_private.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: strtok_r.c,v 1.6 2006/12/26 14:56:20 freddy77 Exp $");
+TDS_RCSID(var, "$Id: strtok_r.c,v 1.7 2010/01/12 10:20:41 freddy77 Exp $");
 
+#undef strtok_r
 char *
 strtok_r(char *str, const char *sep, char **lasts)
 {
@@ -31,12 +32,68 @@ strtok_r(char *str, const char *sep, char **lasts)
 	if (str == NULL) {
 		return NULL;
 	}
-	str += strspn(str, sep);
+	str += strspn(str, sep);	/* skip any separators */
 	if ((p = strpbrk(str, sep)) != NULL) {
 		*lasts = p + 1;
 		*p = '\0';
 	} else {
+		if (!*str)
+			str = NULL;
 		*lasts = NULL;
 	}
 	return str;
 }
+
+#ifdef TDS_INTERNAL_TEST
+
+/* gcc -O2 -Wall strtok_r.c -o strtok -DTDS_INTERNAL_TEST -I../../include -DHAVE_CONFIG_H */
+
+#include <stdlib.h>
+
+static void
+test(const char *s, const char *sep)
+{
+	size_t len = strlen(s);
+	char *c1 = (char*) malloc(len+1);
+	char *c2 = (char*) malloc(len+1);
+	char *last = NULL, *s1, *s2;
+	const char *p1, *p2;
+
+	printf("testint '%s' with '%s' separator(s)\n", s, sep);
+	strcpy(c1, s);
+	strcpy(c2, s);
+
+	s1 = c1;
+	s2 = c2;
+	for (;;) {
+		p1 = strtok(s1, sep);
+		p2 = strtok_r(s2, sep, &last);
+		s1 = s2 = NULL;
+		if ((p1 && !p2) || (!p1 && p2)) {
+			fprintf(stderr, "ptr mistmach %p %p\n", p1, p2);
+			exit(1);
+		}
+		if (!p1)
+			break;
+		if (strcmp(p1, p2) != 0) {
+			fprintf(stderr, "string mistmach '%s' '%s'\n", p1, p2);
+			exit(1);
+		}
+		printf("got string %s\n", p1);
+	}
+	printf("\n");
+}
+
+int
+main(void)
+{
+	test("a b\tc", "\t ");
+	test("    x  y \t  z", " \t");
+	test("a;b;c;", ";");
+	test("a;b;  c;;", ";");
+	test("", ";");
+	test(";;;", ";");
+	return 0;
+}
+#endif
+

